## ros-noetic-picovoice-driver 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(picovoice_driver)

add_compile_options(-std=c++11)

find_package(catkin REQUIRED COMPONENTS
  actionlib
  ddynamic_reconfigure
  picovoice_msgs
  roscpp
  roslib
)

catkin_package(
  CATKIN_DEPENDS
    actionlib
    ddynamic_reconfigure
    picovoice_msgs
    roscpp
    roslib
)

############
### Build ##
############

find_package(PkgConfig)
pkg_check_modules(YAML_CPP yaml-cpp)
if(${YAML_CPP_VERSION} VERSION_GREATER 0.5)
  add_definitions(-DHAVE_NEW_YAMLCPP)
endif()
link_directories(${YAML_CPP_LIBRARY_DIRS})
include_directories(${YAML_CPP_INCLUDE_DIRS})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/)
find_package(LIBSNDFILE REQUIRED)

set(EXTERN ${PROJECT_SOURCE_DIR}/extern)
set(PICOVOICE_INCLUDE_DIRS
  ${EXTERN}/porcupine/include
  ${EXTERN}/rhino/include
  ${EXTERN}/pvrecorder/include
)
set(PICOVOICE_LIBRARIES
  ${EXTERN}/porcupine/lib/linux/x86_64/libpv_porcupine.so
  ${EXTERN}/rhino/lib/linux/x86_64/libpv_rhino.so
  ${EXTERN}/pvrecorder/lib/linux/x86_64/libpv_recorder.so
)

include_directories(
  ${catkin_INCLUDE_DIRS}
  ${LIBSNDFILE_INCLUDE_DIRS}
  ${PICOVOICE_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}
  src/porcupine_recognizer.cpp
  src/recognizer.cpp
  src/rhino_recognizer.cpp
)

target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${LIBSNDFILE_LIBRARIES}
  ${PICOVOICE_LIBRARIES}
  ${YAML_CPP_LIBRARIES}
)

add_executable(test_${PROJECT_NAME}_porcupine
  test/test_porcupine.cpp
)
target_link_libraries(test_${PROJECT_NAME}_porcupine ${PROJECT_NAME})

add_executable(test_${PROJECT_NAME}_rhino
  test/test_rhino.cpp
)
target_link_libraries(test_${PROJECT_NAME}_rhino ${PROJECT_NAME})

add_executable(${PROJECT_NAME}_porcupine
  src/porcupine_node.cpp
  src/ros_util.cpp
)
target_link_libraries(${PROJECT_NAME}_porcupine ${PROJECT_NAME})

add_executable(${PROJECT_NAME}_rhino
  src/rhino_node.cpp
  src/ros_util.cpp
)
target_link_libraries(${PROJECT_NAME}_rhino ${PROJECT_NAME})

##############
### Install ##
##############

install(FILES ${PICOVOICE_LIBRARIES}
  DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(DIRECTORY ${PICOVOICE_INCLUDE_DIRS}
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(DIRECTORY ${PROJECT_SOURCE_DIR}/resources
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_porcupine
    ${PROJECT_NAME}_rhino
    test_${PROJECT_NAME}_porcupine
    test_${PROJECT_NAME}_rhino
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

=== extern/porcupine/demo/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(porcupine_demo_c)

set(CMAKE_C_STANDARD 99)
set(CMAKE_BUILD_TYPE Release)
add_subdirectory(pvrecorder)

set(COMMON_LIBS dl)
set(MIC_LIBS pthread m)

include_directories("${PROJECT_SOURCE_DIR}/../../include")

add_executable(
        porcupine_demo_mic
        porcupine_demo_mic.c
        $<TARGET_OBJECTS:pv_recorder_object>)
target_include_directories(porcupine_demo_mic PRIVATE pvrecorder/include)

add_executable(
        porcupine_demo_file
        porcupine_demo_file.c)
target_include_directories(porcupine_demo_file PRIVATE dr_libs)

if (NOT WIN32)
    target_link_libraries(porcupine_demo_mic ${COMMON_LIBS} ${MIC_LIBS})
    target_link_libraries(porcupine_demo_file ${COMMON_LIBS})
endif()

=== extern/porcupine/demo/python/requirements.txt ===
pvporcupine==2.1.0
pvrecorder==1.0.2

=== extern/porcupine/demo/tkinter/requirements.txt ===
pvporcupine==2.0.0
pvrecorder==1.0.2

=== extern/rhino/demo/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(rhino_demo_c)

set(CMAKE_C_STANDARD 99)
set(CMAKE_BUILD_TYPE Release)
add_subdirectory(pvrecorder)

set(COMMON_LIBS dl)
set(MIC_LIBS pthread m)

include_directories("${PROJECT_SOURCE_DIR}/../../include")

add_executable(
        rhino_demo_mic
        rhino_demo_mic.c
        $<TARGET_OBJECTS:pv_recorder_object>)
target_include_directories(rhino_demo_mic PRIVATE pvrecorder/include)

add_executable(
        rhino_demo_file
        rhino_demo_file.c)
target_include_directories(rhino_demo_file PRIVATE dr_libs)

if (NOT WIN32)
    target_link_libraries(rhino_demo_mic ${COMMON_LIBS} ${MIC_LIBS})
    target_link_libraries(rhino_demo_file ${COMMON_LIBS})
endif()

=== extern/rhino/demo/python/requirements.txt ===
pvrhino==2.1.0
pvrecorder==1.0.2

=== extern/porcupine/demo/c/pvrecorder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(pv_recorder VERSION 1.0.0 DESCRIPTION "Audio recorder library for Picovoice.")

set(CMAKE_C_STANDARD 99)
set(CMAKE_BUILD_TYPE Release)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")

add_library(pv_recorder_object OBJECT src/pv_circular_buffer.c src/pv_recorder.c)

target_include_directories(pv_recorder_object PUBLIC include)
target_include_directories(pv_recorder_object PRIVATE src/miniaudio)

add_library(pv_recorder SHARED $<TARGET_OBJECTS:pv_recorder_object>)

set_target_properties(pv_recorder PROPERTIES
        PUBLIC_HEADER include/pv_recorder.h)

if (NOT WIN32)
    target_link_libraries(pv_recorder pthread dl m)
endif()

if(DEFINED OUTPUT_DIR)
    add_custom_command(TARGET pv_recorder POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE:${PROJECT_NAME}>
            "${CMAKE_SOURCE_DIR}/lib/${OUTPUT_DIR}/$<TARGET_FILE_NAME:${PROJECT_NAME}>"
            COMMENT "Copying to output directory.")
endif()

add_executable(demo example/demo.c)

target_include_directories(demo PUBLIC include)

if (NOT WIN32)
    target_link_libraries(demo pv_recorder pthread dl m)
else()
    target_link_libraries(demo pv_recorder)
endif()

enable_testing()

add_executable(test_circular_buffer test/test_pv_circular_buffer.c src/pv_circular_buffer.c)

target_include_directories(test_circular_buffer PUBLIC include)

add_test(
        NAME test_circular_buffer
        COMMAND test_circular_buffer
)

add_custom_command(
        TARGET test_circular_buffer
        COMMENT "Run Tests"
        POST_BUILD
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMAND ${CMAKE_CTEST_COMMAND} -C $<CONFIGURATION> -R "^test_circular_buffer" --output-on-failures
)

add_subdirectory(node)

=== extern/porcupine/demo/mcu/psoc062s2/Makefile ===
################################################################################
# \file Makefile
# \version 1.0
#
# \brief
# Top-level application make file.
#
################################################################################
# \copyright
# Copyright 2018-2020 Cypress Semiconductor Corporation
# SPDX-License-Identifier: Apache-2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
################################################################################


################################################################################
# Basic Configuration
################################################################################

# Target board/hardware (BSP).
# To change the target, it is recommended to use the Library manager 
# ('make modlibs' from command line), which will also update Eclipse IDE launch 
# configurations. If TARGET is manually edited, ensure TARGET_<BSP>.mtb with a 
# valid URL exists in the application, run 'make getlibs' to fetch BSP contents
# and update or regenerate launch configurations for your IDE.
TARGET=CY8CKIT-062S2-43012

# Name of application (used to derive name of final linked file).
# 
# If APPNAME is edited, ensure to update or regenerate launch 
# configurations for your IDE.
APPNAME=porcupine-demo-psoc6

# Name of toolchain to use. Options include:
#
# GCC_ARM -- GCC provided with ModusToolbox IDE
# ARM     -- ARM Compiler (must be installed separately)
# IAR     -- IAR Compiler (must be installed separately)
#
# See also: CY_COMPILER_PATH below
TOOLCHAIN=GCC_ARM

# Default build configuration. Options include:
#
# Debug -- build with minimal optimizations, focus on debugging.
# Release -- build with full optimizations
# Custom -- build with custom configuration, set the optimization flag in CFLAGS
# 
# If CONFIG is manually edited, ensure to update or regenerate launch configurations 
# for your IDE.
CONFIG=Debug

# If set to "true" or "1", display full command-lines when building.
VERBOSE=


################################################################################
# Advanced Configuration
################################################################################

# Enable optional code that is ordinarily disabled by default.
#
# Available components depend on the specific targeted hardware and firmware
# in use. In general, if you have
#
#    COMPONENTS=foo bar
#
# ... then code in directories named COMPONENT_foo and COMPONENT_bar will be
# added to the build
#
COMPONENTS=PICOVOICE_EN

# Like COMPONENTS, but disable optional code that was enabled by default.
DISABLE_COMPONENTS=

# By default the build system automatically looks in the Makefile's directory
# tree for source code and builds it. The SOURCES variable can be used to
# manually add source code to the build process from a location not searched
# by default, or otherwise not found by the build system.
SOURCES=

# Like SOURCES, but for include directories. Value should be paths to
# directories (without a leading -I).
INCLUDES=

# Add additional defines to the build process (without a leading -D).
DEFINES=

# Select softfp or hardfp floating point. Default is softfp.
VFP_SELECT=hardfp

# Additional / custom C compiler flags.
#
# NOTE: Includes and defines should use the INCLUDES and DEFINES variable
# above.
CFLAGS=

# Additional / custom C++ compiler flags.
#
# NOTE: Includes and defines should use the INCLUDES and DEFINES variable
# above.
CXXFLAGS=

# Additional / custom assembler flags.
#
# NOTE: Includes and defines should use the INCLUDES and DEFINES variable
# above.
ASFLAGS=

# Additional / custom linker flags.
LDFLAGS=

# Additional / custom libraries to link in to the application.
LDLIBS=

# Path to the linker script to use (if empty, use the default linker script).
LINKER_SCRIPT=

# Custom pre-build commands to run.
PREBUILD=

# Custom post-build commands to run.
POSTBUILD=


################################################################################
# Paths
################################################################################

# Relative path to the project directory (default is the Makefile's directory).
#
# This controls where automatic source code discovery looks for code.
CY_APP_PATH=

# Relative path to the shared repo location.
#
# All .mtb files have the format, <URI>#<COMMIT>#<LOCATION>. If the <LOCATION> field 
# begins with $$ASSET_REPO$$, then the repo is deposited in the path specified by 
# the CY_GETLIBS_SHARED_PATH variable. The default location is one directory level 
# above the current app directory.
# This is used with CY_GETLIBS_SHARED_NAME variable, which specifies the directory name.
CY_GETLIBS_SHARED_PATH=../

# Directory name of the shared repo location.
#
CY_GETLIBS_SHARED_NAME=mtb_shared

# Absolute path to the compiler's "bin" directory.
#
# The default depends on the selected TOOLCHAIN (GCC_ARM uses the ModusToolbox
# IDE provided compiler by default).
CY_COMPILER_PATH=


# Locate ModusToolbox IDE helper tools folders in default installation
# locations for Windows, Linux, and macOS.
CY_WIN_HOME=$(subst \,/,$(USERPROFILE))
CY_TOOLS_PATHS ?= $(wildcard \
    $(CY_WIN_HOME)/ModusToolbox/tools_* \
    $(HOME)/ModusToolbox/tools_* \
    /Applications/ModusToolbox/tools_*)

# If you install ModusToolbox IDE in a custom location, add the path to its
# "tools_X.Y" folder (where X and Y are the version number of the tools
# folder). Make sure you use forward slashes.
CY_TOOLS_PATHS+=

# Default to the newest installed tools folder, or the users override (if it's
# found).
CY_TOOLS_DIR=$(lastword $(sort $(wildcard $(CY_TOOLS_PATHS))))

ifeq ($(CY_TOOLS_DIR),)
$(error Unable to find any of the available CY_TOOLS_PATHS -- $(CY_TOOLS_PATHS). On Windows, use forward slashes.)
endif

$(info Tools Directory: $(CY_TOOLS_DIR))

include $(CY_TOOLS_DIR)/make/start.mk

=== extern/porcupine/demo/c/pvrecorder/node/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(pv_recorder_napi)

include(ExternalProject)

set(NODE_VERSION 14.17.5)

ExternalProject_Add(node_headers
  URL https://nodejs.org/dist/v${NODE_VERSION}/node-v${NODE_VERSION}-headers.tar.xz
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
)
ExternalProject_Get_Property(node_headers SOURCE_DIR)
set(NODE_INCLUDE_DIR ${SOURCE_DIR}/include/node/)

if (WIN32)
  set(NODE_WIN_LIB_DIR ${CMAKE_CURRENT_BINARY_DIR}/node_win_lib )
  ExternalProject_Add(node_win_lib
    URL https://nodejs.org/dist/v${NODE_VERSION}/win-x64/node.exe 
    DOWNLOAD_NO_EXTRACT on
    DOWNLOAD_DIR ${NODE_WIN_LIB_DIR}
    CONFIGURE_COMMAND ""
    BUILD_COMMAND gendef.exe ${NODE_WIN_LIB_DIR}/node.exe 
          COMMAND dlltool.exe -d node.def -y ${NODE_WIN_LIB_DIR}/node.a
    INSTALL_COMMAND ""
  )
  set(NODE_LIB ${NODE_WIN_LIB_DIR}/node.a)
endif()

add_library(${PROJECT_NAME} SHARED pv_recorder_napi.c $<TARGET_OBJECTS:pv_recorder_object>)

set_target_properties(${PROJECT_NAME} PROPERTIES
    PREFIX ""
    OUTPUT_NAME "pv_recorder"
    SUFFIX ".node"
)

add_dependencies(${PROJECT_NAME} node_headers)

if (WIN32)
    add_dependencies(${PROJECT_NAME} node_win_lib)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC ${PROJECT_SOURCE_DIR}/../include)
target_include_directories(${PROJECT_NAME} PRIVATE ${NODE_INCLUDE_DIR})

target_link_libraries(${PROJECT_NAME} ${NODE_LIB})

if (APPLE)
    target_link_options(${PROJECT_NAME} PRIVATE "-undefined" "dynamic_lookup")
endif()

if(DEFINED OUTPUT_DIR)
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE:${PROJECT_NAME}>
            "${CMAKE_SOURCE_DIR}/lib/node/${OUTPUT_DIR}/$<TARGET_FILE_NAME:${PROJECT_NAME}>"
            COMMENT "Copying node lib to output directory.")
endif()

=== debian/changelog ===
ros-noetic-picovoice-driver (1.0.1-1focal) focal; urgency=high

  * fix(deps): libsoundfile
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Mon, 28 Mar 2022 22:00:00 -0000

ros-noetic-picovoice-driver (1.0.0-1focal) focal; urgency=high

  * feat: git submodules, pv_recorder, intent filter (#4 <https://github.com/reinzor/picovoice_ros/issues/4>)
  * feat: Use v2.1 api
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Mon, 28 Mar 2022 22:00:00 -0000

ros-noetic-picovoice-driver (0.0.4-1focal) focal; urgency=high

  * Merge pull request #3 <https://github.com/reinzor/picovoice_ros/issues/3> from reinzor/fix/cmake-system-processor
    fix(cmake): Use CMAKE_SYSTEM_PROCESSOR
  * fix(cmake): Use CMAKE_SYSTEM_PROCESSOR
    Should fix the armhf build
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Sun, 11 Apr 2021 22:00:00 -0000

ros-noetic-picovoice-driver (0.0.3-1focal) focal; urgency=high

  * chore: Remove trailing libs
  * Merge pull request #2 <https://github.com/reinzor/picovoice_ros/issues/2> from reinzor/feat/arm-build
    feat: ARM support
  * feat: ARM support
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Mon, 05 Apr 2021 22:00:00 -0000

ros-noetic-picovoice-driver (0.0.2-1focal) focal; urgency=high

  * doc
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Mon, 29 Mar 2021 22:00:00 -0000

ros-noetic-picovoice-driver (0.0.1-1focal) focal; urgency=high

  * Picovoice ROS packages
  * Contributors: Rein Appeldoorn

 -- Rein Appeldoorn <reinzor@gmail.com>  Mon, 29 Mar 2021 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-picovoice-driver
Section: misc
Priority: optional
Maintainer: Rein Appeldoorn <reinzor@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libsndfile1-dev, libyaml-cpp-dev, ros-noetic-actionlib, ros-noetic-catkin, ros-noetic-ddynamic-reconfigure, ros-noetic-picovoice-msgs, ros-noetic-roscpp, ros-noetic-roslib
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-picovoice-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsndfile1-dev, libyaml-cpp-dev, ros-noetic-actionlib, ros-noetic-ddynamic-reconfigure, ros-noetic-picovoice-msgs, ros-noetic-roscpp, ros-noetic-roslib
Description: ROS Wrappers for the Picovoice libraries
